<template src="./product.htm"></template>

<script>

    export default {

        created() {

            this.parseProductAttributes();

        // Preselect if there is only one combination
            if (this.attributesValues.length == 1) {

                if (this.attributesValues[0].values.length == 1) {

                    this.attributesValues[0].valueId = this.attributesValues[0].values[0].id;

                    this.findProductVariant();
                }
            }
        },

        data() {

            return {

                product: this.productData,
                attributesValues: null,
                variant_id: null,
                price: null,
                quantity: 1,
                creatingOrder: false,
                errorMessage: false
            }
        },

        props: ['productData', 'attributesValuesData', 'auth'],

        methods: {

            /**
             * Parse global variable passed from backend on page render.
             */
            parseProduct() {

                this.product = JSON.parse(window.product);
            },


            /**
             * Parse product attributes passed from backend on page render
             */
            parseProductAttributes() {

                this.attributesValues = this.attributesValuesData.map( (el) => {

                    return {

                        attributeId: el.id,

                        attributeName: el.name,

                        values: el.values,

                        valueId: null
                    }
                })
            },


            /**
             * Get small cached product image.
             *
             * @param src
             * @param type
             * @return {*}
             */
            getProductImage(src, type) {

                return route('images.cache', { template: type, filename: src });
            },


            /**
             * When selecting attribute values, find product variant.
             */
            findProductVariant() {

                let variants            = this.product.variants;
                let attributesValues    = this.attributesValues;

                let variant = variants.find( (variant) => {

                    return variant.product_attribute_values.length ===

                        variant.product_attribute_values.filter( (pav) => {

                            return attributesValues.find( (av) => {

                                return av.attributeId == pav.attribute_id && av.valueId == pav.attribute_value_id;
                            });

                        }).length;
                });

                if (variant) {

                    this.variant_id     = variant.id;
                    this.price          = Number(Math.round(parseFloat(variant.price + 'e' + 2)) + 'e-' + 2).toFixed(2);
                    this.errorMessage   = false;
                }
            },


            pushToCart() {

                if (this.creatingOrder == false && this.variant_id !== null) {

                    this.creatingOrder = true;

                    axios.post(route('client.cart.create', { activeProduct: this.product.id, productVariant: this.variant_id }), createRequestObject({quantity: this.quantity}))

                        .then((response) => {

                            this.errorMessage = false;
                            $("#cartModal").modal()
                        })

                        .catch((errors) => {

                            this.errorMessage = 'Odabrani proizvod trenutno nije dostupan!'
                        })

                        .then(() => this.creatingOrder = false)
                }
            }
        }
    }

</script>
